% File lab02_ex_nmr.m
% Generation of random numbers by hand

clear all; close all;

% Uniform [0,1]
r = rand_mult(10000,123);      % multiplicative generator
%r = rand_multadd(10000,123);  % multiplicative + additive generator
    figure; plot(r,'bx'); title('r(n)');
    figure; hist(r,20); title('hist( r(n) )');

% Uniform [0,1] --> Normal(0,1)
N = 10000; r1 = rand(1,N);  r2 = rand(1,N);
n1 = sqrt(-2*log(r1)) .* cos(2*pi*r2);
n2 = sqrt(-2*log(r1)) .* sin(2*pi*r2);
    figure;
    subplot(211); plot(n1); title('n1(n)');
    subplot(212); plot(n2); title('n2(n)');
    figure;
    subplot(211); hist(n1,20); title('hist( n1(n) )');
    subplot(212); hist(n2,20); title('hist( n2(n) )')

%#####################################
function s=rand_mult( N, seed )
a = 69069; p = 2^12; s = zeros(N,1); % specially designed values
for i=1:N
    s(i) = mod(seed*a,p); seed = s(i);
end
s = s/p;
end

%#####################################
function s=rand_multadd( N, seed )
a = 69069; m = 5; p = 2^32; s = zeros(N,1); % specially designed values
for i=1:N
    s(i) = mod(seed*a,p);
    seed = s(i);
end
s = s/p;
end
