% File: Lab02_ex_correlation.m
clear all; close all;

[x,fs] = audioread('A8.wav',[1001,1240]);  % your waveform
x = x(:,1).';                   % only first channel, ().' = vertical-to-horizontal 
Nx = length(x); n=0:Nx-1;       % find number of samples, sample numbers
dt = 1/fs; t = dt*n;            % scale in seconds
K = 180;                        % how many shifts left and right

y = x;                          % more general, ready for cross-correlation
R(K+1) = sum( x .* conj(y) );                               % no shift, k=0
for k = 1 : K                                               % MAIN LOOP
    R(K+1+k) = sum( x(1   : Nx-k) .* conj(y(1+k : Nx  )) ); % shift left
    R(K+1-k) = sum( x(1+k : Nx  ) .* conj(y(1   : Nx-k)) ); % shift right
end                                                         %
k = -K : K;
figure
subplot(211); plot(t,x,'b.-'); xlabel('t  (s)'); title('Signal fragment'); grid;
subplot(212); plot( k*dt, R, 'b.-'); xlabel('\tau  (s)'); title('Signal auto-correlation'); grid;