% File: Lab02_ex_deterministic.m
clear all; close all;

fs = 1000;      % sampling frequency (samples per second):
N = 1000;       % number of samples to generate
dt = 1/fs;      % time between samples
n = 0 : N-1;    % vector of sample indexes
t = dt * n;     % vector of sampling time moments
x1 = sin( 2*pi*5*t ); % sinusoid repeating of 5 times per second
x2 = exp( -10*t );    % exponent with damping factor 10
x3 = exp( -25*(t-0.5).^2 );  % Gaussian centered at t=0.5s with damping factor 25
x4a = sin( 2*pi*( 100*t + 90*cumsum(x1)*dt ) ); % signal modulated in frequency by x1
x4b = sin( 2*pi*( 100*t - 90/(2*pi*5)*cos(2*pi*5*t) ) ); % the same theoretically
x5 = 1/3*randn(1,N);         % NOBODY IS PERFECT! disturbing noise
figure;
subplot(6,1,1); plot(t,x1, 'b.-'); grid; title('x(t)');
subplot(6,1,2); plot(t,x2, 'b.-'); grid;
subplot(6,1,3); plot(t,x3, 'b.-'); grid;
subplot(6,1,4); plot(t,x4a,'b.-'); grid;
subplot(6,1,5); plot(t,x4b,'b.-'); grid;
subplot(6,1,6); plot(t,x5, 'b.-'); grid; xlabel('t [s]'); 