% File lab02_ex_doremi.m
% Synthetic music - playing musical gamma and any song

clear all; close all;

fs = 8000;  T = 0.5;  % sampling frequency, note duration
dt = 1/fs;  N = round(T/dt);  t = dt*(0:N-1);
damp = exp(-t/(T/2));

% Musical note frequencies
%          C      D      E      F      G      A      H
%          do     re     mi     fa     sol    la     si
freqs  = [ 261.6, 293.7, 329.6, 349.6, 391.9, 440.0, 493.9 ];
kb = [ freqs; 2*freqs ]; % keybord;
temp = kb'; f = temp(:),

% Musical scale
mscale = [];        
for k = 1 : length(f)
    x = damp .* sin(2*pi*f(k)*t);
    mscale = [ mscale x ];
end
soundsc( mscale,fs );
pause( T * (length(f)+1) );

% My song
myfreqs = [ kb(1,5) kb(1,5) kb(1,6) kb(1,5) kb(2,1) kb(1,7) ...
            kb(1,5) kb(1,5) kb(1,6) kb(1,5) kb(2,2) kb(1,2) ...
            kb(1,5) kb(1,5) kb(2,5) kb(2,3) kb(2,1) kb(1,7) kb(1,6) ...
            kb(2,4) kb(2,4) kb(2,3) kb(2,1) kb(2,2) kb(2,1) ];
mysong = [];        
for k = 1 : length(myfreqs)
    x = damp .* sin( 2*pi*myfreqs(k)*t );
    mysong = [ mysong x ];
end
soundsc(mysong,fs);
